searchNodes=[{"doc":"Req plugin for Google BigQuery . ReqBigQuery makes it easy to make BigQuery queries. It uses Goth for authentication. Query results are decoded into the ReqBigQuery.Result struct. The struct implements the Table.Reader protocol and thus can be efficiently traversed by rows or columns.","ref":"ReqBigQuery.html","title":"ReqBigQuery","type":"module"},{"doc":"Attaches to Req request. Request Options :goth - Required. The goth server name. :project_id - Required. The GCP project id. :bigquery - Required. The query to execute. It can be a plain sql string or a {query, params} tuple, where query can contain ? placeholders and params is a list of corresponding values. :default_dataset_id - Optional. If set, the dataset to assume for any unqualified table names in the query. If not set, all table names in the query string must be qualified in the format 'datasetId.tableId'. :max_results - Optional. Number of rows to be returned by BigQuery in each request (paging). The rows Stream can make multiple requests if num_rows returned is grather than :max_results . Defaults to 10000. If you want to set any of these options when attaching the plugin, pass them as the second argument. Examples With plain query string: iex&gt; credentials = File . read! ( &quot;credentials.json&quot; ) |&gt; Jason . decode! ( ) iex&gt; source = { :service_account , credentials , [ ] } iex&gt; { :ok , _ } = Goth . start_link ( name : MyGoth , source : source , http_client : &amp; Req . request / 1 ) iex&gt; project_id = System . fetch_env! ( &quot;PROJECT_ID&quot; ) iex&gt; query = &quot;&quot;&quot; ...&gt; SELECT title, SUM(views) AS views ...&gt; FROM `bigquery-public-data.wikipedia.table_bands` ...&gt; WHERE EXTRACT(YEAR FROM datehour) &lt;= 2021 ...&gt; GROUP BY title ...&gt; ORDER BY views DESC ...&gt; LIMIT 10 ...&gt; &quot;&quot;&quot; iex&gt; req = Req . new ( ) |&gt; ReqBigQuery . attach ( goth : MyGoth , project_id : project_id ) iex&gt; res = Req . post! ( req , bigquery : query ) . body iex&gt; res % ReqBigQuery.Result { columns : [ &quot;title&quot; , &quot;views&quot; ] , job_id : &quot;job_JDDZKquJWkY7x0LlDcmZ4nMQqshb&quot; , num_rows : 10 , rows : % Stream { } } iex&gt; Enum . to_list ( res . rows ) [ [ &quot;The_Beatles&quot; , 13758950 ] , [ &quot;Queen_(band)&quot; , 12019563 ] , [ &quot;Pink_Floyd&quot; , 9522503 ] , [ &quot;AC/DC&quot; , 8972364 ] , [ &quot;Led_Zeppelin&quot; , 8294994 ] , [ &quot;Linkin_Park&quot; , 8242802 ] , [ &quot;The_Rolling_Stones&quot; , 7825952 ] , [ &quot;Red_Hot_Chili_Peppers&quot; , 7302904 ] , [ &quot;Fleetwood_Mac&quot; , 7199563 ] , [ &quot;Twenty_One_Pilots&quot; , 6970692 ] ] With parameterized query: iex&gt; credentials = File . read! ( &quot;credentials.json&quot; ) |&gt; Jason . decode! ( ) iex&gt; source = { :service_account , credentials , [ ] } iex&gt; { :ok , _ } = Goth . start_link ( name : MyGoth , source : source , http_client : &amp; Req . request / 1 ) iex&gt; project_id = System . fetch_env! ( &quot;PROJECT_ID&quot; ) iex&gt; query = &quot;&quot;&quot; ...&gt; SELECT EXTRACT(YEAR FROM datehour) AS year, SUM(views) AS views ...&gt; FROM `bigquery-public-data.wikipedia.table_bands` ...&gt; WHERE EXTRACT(YEAR FROM datehour) &lt;= 2021 ...&gt; AND title = ? ...&gt; GROUP BY 1 ...&gt; ORDER BY views DESC ...&gt; &quot;&quot;&quot; iex&gt; req = Req . new ( ) |&gt; ReqBigQuery . attach ( goth : MyGoth , project_id : project_id ) iex&gt; res = Req . post! ( req , bigquery : { query , [ &quot;Linkin_Park&quot; ] } ) . body % ReqBigQuery.Result { columns : [ &quot;year&quot; , &quot;views&quot; ] , job_id : &quot;job_GXiJvALNsTAoAOJ39Eg3Mw94XMUQ&quot; , num_rows : 7 , rows : % Stream { } } iex&gt; Enum . to_list ( res . rows ) [ [ 2017 , 2895889 ] , [ 2016 , 1173359 ] , [ 2018 , 1133770 ] , [ 2020 , 906538 ] , [ 2015 , 860899 ] , [ 2019 , 790747 ] , [ 2021 , 481600 ] ]","ref":"ReqBigQuery.html#attach/2","title":"ReqBigQuery.attach/2","type":"function"},{"doc":"Result struct returned from any successful query. Its fields are: columns - The column names; rows - The result set. A list of lists, each inner list corresponding to a row, each element in the inner list corresponds to a column; num_rows - The number of fetched or affected rows; job_id - The ID of the Google BigQuery's executed job.","ref":"ReqBigQuery.Result.html","title":"ReqBigQuery.Result","type":"module"},{"doc":"","ref":"ReqBigQuery.Result.html#t:t/0","title":"ReqBigQuery.Result.t/0","type":"type"},{"doc":"Req plugin for Google BigQuery . ReqBigQuery makes it easy to make BigQuery queries. It uses Goth for authentication. Query results are decoded into the ReqBigQuery.Result struct. The struct implements the Table.Reader protocol and thus can be efficiently traversed by rows or columns.","ref":"readme.html","title":"ReqBigQuery","type":"extras"},{"doc":"Mix . install ( [ { :goth , &quot;~&gt; 1.3.0&quot; } , { :req , &quot;~&gt; 0.3.5&quot; } , { :req_bigquery , &quot;~&gt; 0.1.1&quot; } ] ) # We use Goth to authenticate to Google Cloud API. # See: https://hexdocs.pm/goth/1.3.0-rc.4/Goth.Token.html#fetch/1-source for more information. credentials = File . read! ( &quot;credentials.json&quot; ) |&gt; Jason . decode! ( ) source = { :service_account , credentials , [ ] } { :ok , _ } = Goth . start_link ( name : MyGoth , source : source , http_client : &amp; Req . request / 1 ) project_id = System . fetch_env! ( &quot;PROJECT_ID&quot; ) # With plain string query query = &quot;&quot;&quot; SELECT title, SUM(views) AS views FROM `bigquery-public-data.wikipedia.table_bands` WHERE EXTRACT(YEAR FROM datehour) &lt;= 2021 GROUP BY title ORDER BY views DESC LIMIT 10 &quot;&quot;&quot; req = Req . new ( ) |&gt; ReqBigQuery . attach ( goth : MyGoth , project_id : project_id ) res = Req . post! ( req , bigquery : query ) . body #=&gt; # %ReqBigQuery.Result{ # columns: [&quot;title&quot;, &quot;views&quot;], # job_id: &quot;job_JDDZKquJWkY7x0LlDcmZ4nMQqshb&quot;, # num_rows: 10, # rows: %Stream{} # } Enum . to_list ( res . rows ) #=&gt; # [ # [&quot;The_Beatles&quot;, 13758950], # [&quot;Queen_(band)&quot;, 12019563], # [&quot;Pink_Floyd&quot;, 9522503], # [&quot;AC/DC&quot;, 8972364], # [&quot;Led_Zeppelin&quot;, 8294994], # [&quot;Linkin_Park&quot;, 8242802], # [&quot;The_Rolling_Stones&quot;, 7825952], # [&quot;Red_Hot_Chili_Peppers&quot;, 7302904], # [&quot;Fleetwood_Mac&quot;, 7199563], # [&quot;Twenty_One_Pilots&quot;, 6970692] # ] # With parameterized query query = &quot;&quot;&quot; SELECT EXTRACT(YEAR FROM datehour) AS year, SUM(views) AS views FROM `bigquery-public-data.wikipedia.table_bands` WHERE EXTRACT(YEAR FROM datehour) &lt;= 2021 AND title = ? GROUP BY year ORDER BY views DESC &quot;&quot;&quot; req = Req . new ( ) |&gt; ReqBigQuery . attach ( goth : MyGoth , project_id : project_id ) res = Req . post! ( req , bigquery : { query , [ &quot;Linkin_Park&quot; ] } ) . body #=&gt; # %ReqBigQuery.Result{ # columns: [&quot;year&quot;, &quot;views&quot;], # job_id: &quot;job_GXiJvALNsTAoAOJ39Eg3Mw94XMUQ&quot;, # num_rows: 7, # rows: %Stream{} # } Enum . to_list ( res . rows ) #=&gt; [[2017, 2895889], [2016, 1173359], [2018, 1133770], [2020, 906538], [2015, 860899], [2019, 790747], [2021, 481600]]","ref":"readme.html#usage","title":"ReqBigQuery - Usage","type":"extras"},{"doc":"Copyright (C) 2022 Dashbit Licensed under the Apache License , Version 2.0 ( the &quot;License&quot; ) ; you may not use this file except in compliance with the License . You may obtain a copy of the License at [ http :// www . apache . org / licenses / LICENSE - 2.0 ] ( http :// www . apache . org / licenses / LICENSE - 2.0 ) Unless required by applicable law or agreed to in writing , software distributed under the License is distributed on an &quot;AS IS&quot; BASIS , WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND , either express or implied . See the License for the specific language governing permissions and limitations under the License .","ref":"readme.html#license","title":"ReqBigQuery - License","type":"extras"}]